=== tools/CMakeLists.txt ===

ADD_SUBDIRECTORY( ConsoleApp )
ADD_SUBDIRECTORY( ImagesJoiner )
ADD_SUBDIRECTORY( ExtractObject )
ADD_SUBDIRECTORY( Camera )
ADD_SUBDIRECTORY( StereoEval )
ADD_SUBDIRECTORY( KittiDataset )
ADD_SUBDIRECTORY( RgbdDataset )
ADD_SUBDIRECTORY( EurocDataset )
ADD_SUBDIRECTORY( Recovery )
ADD_SUBDIRECTORY( Reprocess )
ADD_SUBDIRECTORY( DetectMoreLoopClosures )
ADD_SUBDIRECTORY( Export )
ADD_SUBDIRECTORY( Report )
ADD_SUBDIRECTORY( Info )

IF(OPENCV_NONFREE_FOUND)
ADD_SUBDIRECTORY( VocabularyComparison )
ENDIF(OPENCV_NONFREE_FOUND)

IF(TARGET rtabmap_gui)
	ADD_SUBDIRECTORY( CameraRGBD )
	ADD_SUBDIRECTORY( DatabaseViewer )
	ADD_SUBDIRECTORY( EpipolarGeometry )
	ADD_SUBDIRECTORY( OdometryViewer )
	ADD_SUBDIRECTORY( DataRecorder )
	ADD_SUBDIRECTORY( Calibration )
	ADD_SUBDIRECTORY( Matcher )
ELSE()
   MESSAGE(STATUS "RTAB-Map GUI lib is not built, some tools won't be built...")
ENDIF()
