=== debian/changelog ===
ros-melodic-rtabmap (0.20.0-2stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Sun, 12 Jul 2020 19:06:04 -0000
